($jobdir,$resolution)=@ARGV;
chdir "../$jobdir";
system (mkdir "sh");

$genome_length = 3101788170;      #The genome length of species. default : (human). U can Change it if necessary.

$min=($resolution/$genome_length*0.1)**(1/3)*3*2;
$ll1=($resolution/$genome_length*0.1)**(1/3)*3*2;
$ll2=($resolution/$genome_length*0.4)**(1/3)*3*2;
#if ($resolution%8000 != 0){
#	$resolution=int(int($resolution/8000)+0.5)*8000;
#}
@pfiles=<*.p>;
foreach (@pfiles) {
	open i, "$_";
	#print "$_\n";
	$n1=0;
	while (<i>) {
	$n1++;
		chomp;
		@line=split/\t/,$_;
		$n2=0;
		foreach (@line) {
			if ($_ ==0) {
				$_=1;
			}
			$n2++;
			$pvalue{$n1}{$n2}=$_;			
		}
	}
	close i;
}
@files=<*.txt>;
#print "@files\n";
foreach  $file(@files) {
	if ($file=~/.*\.chr(.*)\.arm(.*)\.dist/) {
		$chr=$1;
		$arm=$2;
	}
	$_=$file;
	s/.txt//;
	$file2=$_;
	open i, "$file";	
	#print "$file\n";
	
	open o, ">sh/$file2.ltf";
	print o "MODEL:\n";
	print o "min=";
	$n1=0;
	$n3=0;
	while (<i>) {
		$n1++;
		chomp;
		@line=split/\t/,$_;
		$n2=0;
		foreach  $deta(@line) {
			$n2++;
			if ($deta>0 && $n1 < $n2) {
				$n3++;
				if ($n3==1) {
					print o "((((x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2)^0.5-$deta)^2)/($deta^2)";
				}else{
					print o "\n+((((x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2)^0.5-$deta)^2)/($deta^2)";
				}
				# if ($n3==1) {
					# print o "((((x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2)^0.5-$deta)^2)*$pvalue{$n1}{$n2}";
				# }else{
					# print o "\n+((((x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2)^0.5-$deta)^2)*$pvalue{$n1}{$n2}";
				# }
			}

		}

	}
	close i;
	print o "\;\n";
	
	#Initial Model Value Files for lingo.
	%loc = ();
	$loc{8000} = 'init_8000.loc';
	$loc{16000} = 'init_16000.loc';
	$loc{32000} = 'init_32000.loc';
	$loc{64000} = 'init_64000.loc';
	$loc{128000} = 'init_128000.loc';
	$loc{256000} = 'init_256000.loc';
	$loc{512000} = 'init_512000.loc';
	$loc{1024000} = 'init_1024000.loc';
	
	#Choose the nearby Initial Value File for your resolution.
	if ($resolution <= 12000){$loc_file = $loc{8000};}
	if ($resolution > 12000 && $resolution <= 24000){$loc_file = $loc{16000};}
	if ($resolution > 24000 && $resolution <= 48000){$loc_file = $loc{32000};}
	if ($resolution > 48000 && $resolution <= 96000){$loc_file = $loc{64000};}
	if ($resolution > 96000 && $resolution <= 192000){$loc_file = $loc{128000};}
	if ($resolution > 192000 && $resolution <= 384000){$loc_file = $loc{256000};}
	if ($resolution > 384000 && $resolution <= 768000){$loc_file = $loc{512000};}
	if ($resolution > 768000){$loc_file = $loc{1024000};}
	
	
	#open i, "../../programs/init\_$resolution.loc";
	print "Initial Value File : $loc_file\n";
	open i, "../../programs/$loc_file";
	#open i, "init.loc";
	print o "INIT\:\n";
	$no=0;
	while (<i>) {
		chomp;
		($x,$y,$z)=split/\t/,$_;
		if ($no<$n1) {
			$no++;
			print o "x$no=$x\;\n";
			print o "y$no=$y\;\n";
			print o "z$no=$z\;\n";	
		}
		
	}
	close i;
	print o "ENDINIT\n";
	$no=$n1;
	for (1..$no) {
		print o "x$_^2+y$_^2+z$_^2<3^2\;\n";
	}
#	open i, "$file2.radius";
#	my(%r);
#	$n1=0;
#	while (<i>) {
#		$n1++;
#		chomp;
#		$r{$n1}=$_;
#	}
#	for (1..$no-1) {
#		$n1=$_;
#		$n2=$n1+1;
#		$rr=$r{$n1}+$r{$n2};
#		print o "(x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2<(1.5*$rr)^2\;\n";
#		print o "(x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2>(0.8*$rr)^2\;\n";
#		
#	}
	for (1..$no-1) {
		$n1=$_;
		$n2=$n1+1;
		print o "(x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2<$ll2^2\;\n";
		print o "(x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2>$ll1^2\;\n";
		
	}
	for (1..$no-2) {
		$n1=$_;
		for ($n1+2..$no) {
			$n2=$_;
			print o "(x$n1-x$n2)^2+(y$n1-y$n2)^2+(z$n1-z$n2)^2>$min^2\;\n";

		}
	}

	for (1..$no) {
		print o "\@free\(x$_\)\;\n";
		print o "\@free\(y$_\)\;\n";
		print o "\@free\(z$_\)\;\n";
	}
	print o "END\nGO\n$file2.TXT\nSOLUTION\nRVRT\nQUIT\n";
	
	open sh, ">sh/$file2.sh";
    print sh "#!/bin/sh\n";
	print sh "LINGO_13_HOME=/var/www/lingo13\n";
	print sh "export LINGO_13_HOME\n";
	print sh "LD_LIBRARY_PATH=\$LINGO_13_HOME/bin/linux64:\$LD_LIBRARY_PATH\n";
	print sh "export LD_LIBRARY_PATH\n";
	print sh "\#source \$LINGO_13_HOME/bin/linux64/lingovars.sh\n";
	print sh "PATH=\$PATH:\$LINGO_13_HOME/bin/linux64\n";
	print sh "export PATH\n";
	print sh "alias lingo=lingo64_13\n";
	print sh "lingo < $file2.ltf > $file2.lgr\n";
	close sh;
	close o;



}
